import { AxiosRequestConfig } from "axios";
import { useEffect, useState } from "react";
import { Api } from "src/axios/axios.util";
import useApi, { useApiProps } from "./useApi";
import AsyncStorage from "@react-native-async-storage/async-storage";

export default function useProtectedApi<T>({
  dependencies = [],
  ...request
}: useApiProps) {
  const response = async () => {
    const authToken = await AsyncStorage.getItem("authToken");

    return useApi<T>({
      ...request,
      dependencies: [...dependencies, authToken],
      headers: { Authorization: `Bearer ${authToken}` },
    });
  };

  return response();
}
